%global debug_package %{nil}

Name:           outcome-devel
Version:        2.2.7
Release:        1%{?dist}
Summary:        Provides very lightweight outcome<T> and result<T> (non-Boost edition)
BuildArch:      noarch
License:        Apache-2.0 OR BSL-1.0
URL:            https://github.com/ned14/outcome
Source0:        https://github.com/ned14/outcome/releases/download/v2.2.7/outcome-v2-all-sources-018620768577911c9b259275a5957525d55ad09a.tar.xz

BuildRequires: cmake
BuildRequires: gcc-c++

%description
Header only library that provides very lightweight outcome<T> and result<T> (non-Boost edition)

%prep
%autosetup -n outcome -p1

%build
%cmake -DCMAKE_BUILD_TYPE=Release -DOUTCOME_BUNDLE_EMBEDDED_QUICKCPPLIB=ON -DCMAKE_INSTALL_DATADIR=%{_datadir}/outcome
%cmake_build

%check
%ctest

%install
%cmake_install

%files
%{_includedir}/outcome/bad_access.hpp
%{_includedir}/outcome/basic_outcome.hpp
%{_includedir}/outcome/basic_result.hpp
%{_includedir}/outcome/boost_outcome.hpp
%{_includedir}/outcome/boost_result.hpp
%{_includedir}/outcome/config.hpp
%{_includedir}/outcome/convert.hpp
%{_includedir}/outcome/coroutine_support.hpp
%{_includedir}/outcome/detail/basic_outcome_exception_observers.hpp
%{_includedir}/outcome/detail/basic_outcome_exception_observers_impl.hpp
%{_includedir}/outcome/detail/basic_outcome_failure_observers.hpp
%{_includedir}/outcome/detail/basic_result_error_observers.hpp
%{_includedir}/outcome/detail/basic_result_final.hpp
%{_includedir}/outcome/detail/basic_result_storage.hpp
%{_includedir}/outcome/detail/basic_result_value_observers.hpp
%{_includedir}/outcome/detail/coroutine_support.ipp
%{_includedir}/outcome/detail/revision.hpp
%{_includedir}/outcome/detail/trait_std_error_code.hpp
%{_includedir}/outcome/detail/trait_std_exception.hpp
%{_includedir}/outcome/detail/value_storage.hpp
%{_includedir}/outcome/detail/version.hpp
%{_includedir}/outcome/experimental/coroutine_support.hpp
%{_includedir}/outcome/experimental/result.h
%{_includedir}/outcome/experimental/status-code/include/status-code/boost_error_code.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/com_code.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/config.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/detail/nt_code_to_generic_code.ipp
%{_includedir}/outcome/experimental/status-code/include/status-code/detail/nt_code_to_win32_code.ipp
%{_includedir}/outcome/experimental/status-code/include/status-code/detail/win32_code_to_generic_code.ipp
%{_includedir}/outcome/experimental/status-code/include/status-code/error.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/errored_status_code.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/generic_code.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/getaddrinfo_code.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/http_status_code.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/iostream_support.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/nested_status_code.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/nt_code.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/posix_code.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/quick_status_code_from_enum.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/result.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/status_code.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/status_code_domain.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/status_error.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/std_error_code.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/system_code.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/system_code_from_exception.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/system_error2.hpp
%{_includedir}/outcome/experimental/status-code/include/status-code/win32_code.hpp
%{_includedir}/outcome/experimental/status-code/single-header/system_error2.hpp
%{_includedir}/outcome/experimental/status_outcome.hpp
%{_includedir}/outcome/experimental/status_result.hpp
%{_includedir}/outcome/iostream_support.hpp
%{_includedir}/outcome/outcome.hpp
%{_includedir}/outcome/outcome.natvis
%{_includedir}/outcome/policy/all_narrow.hpp
%{_includedir}/outcome/policy/base.hpp
%{_includedir}/outcome/policy/fail_to_compile_observers.hpp
%{_includedir}/outcome/policy/outcome_error_code_throw_as_system_error.hpp
%{_includedir}/outcome/policy/outcome_exception_ptr_rethrow.hpp
%{_includedir}/outcome/policy/result_error_code_throw_as_system_error.hpp
%{_includedir}/outcome/policy/result_exception_ptr_rethrow.hpp
%{_includedir}/outcome/policy/terminate.hpp
%{_includedir}/outcome/policy/throw_bad_result_access.hpp
%{_includedir}/outcome/result.hpp
%{_includedir}/outcome/std_outcome.hpp
%{_includedir}/outcome/std_result.hpp
%{_includedir}/outcome/success_failure.hpp
%{_includedir}/outcome/trait.hpp
%{_includedir}/outcome/try.hpp
%{_includedir}/outcome/utils.hpp
%{_includedir}/outcome.hpp
%{_includedir}/quickcpplib/algorithm/bit_interleave.hpp
%{_includedir}/quickcpplib/algorithm/bitwise_trie.hpp
%{_includedir}/quickcpplib/algorithm/hash.hpp
%{_includedir}/quickcpplib/algorithm/memory.hpp
%{_includedir}/quickcpplib/algorithm/open_hash_index.hpp
%{_includedir}/quickcpplib/algorithm/prime_modulus.hpp
%{_includedir}/quickcpplib/algorithm/secded_ecc.hpp
%{_includedir}/quickcpplib/algorithm/small_prng.hpp
%{_includedir}/quickcpplib/algorithm/string.hpp
%{_includedir}/quickcpplib/aligned_allocator.hpp
%{_includedir}/quickcpplib/allocator_testing.hpp
%{_includedir}/quickcpplib/bit_cast.hpp
%{_includedir}/quickcpplib/bitfield.hpp
%{_includedir}/quickcpplib/boost/test/unit_test.hpp
%{_includedir}/quickcpplib/byte.hpp
%{_includedir}/quickcpplib/byte/include/nonstd/byte.hpp
%{_includedir}/quickcpplib/byte/test/byte-main.t.hpp
%{_includedir}/quickcpplib/byte/test/lest/lest_cpp03.hpp
%{_includedir}/quickcpplib/config.hpp
%{_includedir}/quickcpplib/console_colours.hpp
%{_includedir}/quickcpplib/cpp_feature.h
%{_includedir}/quickcpplib/declval.hpp
%{_includedir}/quickcpplib/detach_cast.hpp
%{_includedir}/quickcpplib/detail/impl/execinfo_win64.ipp
%{_includedir}/quickcpplib/detail/impl/signal_guard.ipp
%{_includedir}/quickcpplib/detail/preprocessor_macro_overload.h
%{_includedir}/quickcpplib/erasure_cast.hpp
%{_includedir}/quickcpplib/execinfo_win64.h
%{_includedir}/quickcpplib/function_ptr.hpp
%{_includedir}/quickcpplib/import.h
%{_includedir}/quickcpplib/in_place_detach_attach.hpp
%{_includedir}/quickcpplib/mem_flush_loads_stores.hpp
%{_includedir}/quickcpplib/memory_resource.hpp
%{_includedir}/quickcpplib/offset_ptr.hpp
%{_includedir}/quickcpplib/optional.hpp
%{_includedir}/quickcpplib/optional/optional.hpp
%{_includedir}/quickcpplib/packed_backtrace.hpp
%{_includedir}/quickcpplib/revision.hpp
%{_includedir}/quickcpplib/ringbuffer_log.hpp
%{_includedir}/quickcpplib/scope.hpp
%{_includedir}/quickcpplib/signal_guard.hpp
%{_includedir}/quickcpplib/span-lite/example/nonstd/span.tweak.hpp
%{_includedir}/quickcpplib/span-lite/include/nonstd/span.hpp
%{_includedir}/quickcpplib/span-lite/test/lest/lest_cpp03.hpp
%{_includedir}/quickcpplib/span-lite/test/nonstd/span.tweak.hpp
%{_includedir}/quickcpplib/span-lite/test/span-main.t.hpp
%{_includedir}/quickcpplib/span.hpp
%{_includedir}/quickcpplib/spinlock.hpp
%{_includedir}/quickcpplib/spinlock.natvis
%{_includedir}/quickcpplib/start_lifetime_as.hpp
%{_includedir}/quickcpplib/string_view.hpp
%{_includedir}/quickcpplib/tribool.hpp
%{_includedir}/quickcpplib/type_traits.hpp
%{_includedir}/quickcpplib/uint128.hpp
%{_includedir}/quickcpplib/utils/thread.hpp
%{_includedir}/quickcpplib/valgrind/drd.h
%{_includedir}/quickcpplib/valgrind/helgrind.h
%{_includedir}/quickcpplib/valgrind/memcheck.h
%{_includedir}/quickcpplib/valgrind/valgrind.h

%{_libdir}/cmake/outcome/outcomeConfig.cmake
%{_libdir}/cmake/outcome/outcomeExports.cmake
%{_libdir}/cmake/quickcpplib/quickcpplibConfig.cmake
%{_libdir}/cmake/quickcpplib/quickcpplibExports.cmake

%{_datadir}/outcome/cmakelib/DownloadBuildInstall.cmake.in
%{_datadir}/outcome/cmakelib/ProjectConfig.cmake.in
%{_datadir}/outcome/cmakelib/QuickCppLibApplyDefaultDefinitions.cmake
%{_datadir}/outcome/cmakelib/QuickCppLibCacheLibrarySources.cmake
%{_datadir}/outcome/cmakelib/QuickCppLibMakeDoxygen.cmake
%{_datadir}/outcome/cmakelib/QuickCppLibMakeExport.cmake
%{_datadir}/outcome/cmakelib/QuickCppLibMakeHeaderOnlyLibrary.cmake
%{_datadir}/outcome/cmakelib/QuickCppLibMakeInstall.cmake
%{_datadir}/outcome/cmakelib/QuickCppLibMakeLibrary.cmake
%{_datadir}/outcome/cmakelib/QuickCppLibMakeStandardTests.cmake
%{_datadir}/outcome/cmakelib/QuickCppLibParseLibrarySources.cmake
%{_datadir}/outcome/cmakelib/QuickCppLibPolicies.cmake
%{_datadir}/outcome/cmakelib/QuickCppLibRequireOutOfSourceBuild.cmake
%{_datadir}/outcome/cmakelib/QuickCppLibSetupProject.cmake
%{_datadir}/outcome/cmakelib/QuickCppLibUtils.cmake
%{_datadir}/outcome/cmakelib/quickcpplibConfig.override.cmake.in
%{_datadir}/outcome/scripts/GenSingleHeader.py
%{_datadir}/outcome/scripts/IndentCmacros.py
%{_datadir}/outcome/scripts/TabsToSpaces.py
%{_datadir}/outcome/scripts/add_junit_results_to_ctest.py
%{_datadir}/outcome/scripts/boost-test-to-junit.xsl
%{_datadir}/outcome/scripts/boostify.py
%{_datadir}/outcome/scripts/boostify_git_repo.py
%{_datadir}/outcome/scripts/cpp-pm/CMakeLists.txt
%{_datadir}/outcome/scripts/cpp-pm/cmake/HunterGate.cmake
%{_datadir}/outcome/scripts/cpp-pm/cmake/HunterVersion.cmake
%{_datadir}/outcome/scripts/gen_guard_matrix.py
%{_datadir}/outcome/scripts/make_deb.py
%{_datadir}/outcome/scripts/merge_develop_to_master_if_good.py
%{_datadir}/outcome/scripts/merge_junit_results.py
%{_datadir}/outcome/scripts/restamp_licence.py
%{_datadir}/outcome/scripts/run-clang-tidy.py
%{_datadir}/outcome/scripts/send_to_wandbox.py
%{_datadir}/outcome/scripts/test_cpp-pm_install.py

%license Licence.txt
%doc Readme.md



%changelog
* Tue Oct 31 2023 Andrew Potter <agpotter@gmail.com> - 2.2.7-1
- Release 2.2.7

* Wed Aug 10 2022 Andrew Potter <agpotter@gmail.com> - v2.2.3
- Initial version of package
